module One
  module Backup
    class HapyImage
      attr_reader :id, :source, :vms, :running_vms
      def initialize(imgObject)
        @id = imgObject.to_hash['IMAGE']['ID']
        @image = imgObject
        @info  = imgObject.to_hash['IMAGE']
        @owner = @info['UNAME']
        @source = @info['SOURCE']
        @vms = @info['VMS']
        @running_vms = @info['RUNNING_VMS']
      end
    
      def name
        return @image.name
      end
    
      def persistent
        if @info['PERSISTENT'] == "1"
          return true
        else
          return false
        end
      end
    
      def remove
        begin
          @image.delete
        rescue
          @image.info
          begin
            @image.delete
          rescue
            return false
          end
          return true
        end
      end
    
      def status
        @image.info
        @info = @image.to_hash['IMAGE']
        return @image.short_state_str
      end
    
      def show
        print("#{self.name}\n")
        print("\tOwner: #{self.owner}\n")
        print("\tPersistent: #{self.persistant}\n")
        print("\tSource: #{self.source}\n")
        print("\tvms: #{self.vms}\n")
        print("\trunning_vms: #{self.running_vms}\n")
      end
    end
  end
end    