module One
   module Utils
      def self.copyImage(source, dest, orisum, compress=false)
         #if File.symlink?(source)
         #    source=File.readlink(source)
         #end
         if ! File.exists?(File.dirname(dest))
          FileUtils.mkdir_p(File.dirname(dest))
         end
         if compress
            res = compressImage(source, dest)
            if res == 0
               LOGGER.info("Image #{source} saved to #{dest}")
               return true
            else
               LOGGER.error("Saving #{source} to #{dest} failed")
               return false
            end
         else
            dest.delete("\s")
            if File.exists?(dest)
               dsum = Digest::SHA1.file(dest)
               if orisum == dsum
                  LOGGER.info("Destination #{dest} and origin file #{source} identical")
                  return true
               end
            end
            LOGGER.info("cp #{source} #{dest}")
            FileUtils.cp(source, dest)
            newsum = Digest::SHA1.file(dest)
            if orisum == newsum
               LOGGER.info("Image #{source} saved to #{dest}")
               return true
            else
               LOGGER.error("Saving #{source} to #{dest} failed")
               return false
            end
         end
      end
   end

   #
   # NAME: compressImage
   # PARAM:
   #    - source: file to compress
   # AIM: Copy Disk file into the backup directory
   #
   def self.compressImage(source, dest=nil)
      if not dest
         dest = "#{source}.z"
      end
      LOGGER.info("Compression of #{source} into #{dest}")
      system("qemu-img convert -O qcow2 -c '#{source}' '#{dest}'")
      return $?.exitstatus
   end

end